#! /bin/sh

# --------------------------------------------------------------------------
#  BRI ADAPTER CONFIGURATION SCRIPT
#  Copyright by Eicon Networks 1993-2000
# --------------------------------------------------------------------------

bri_adapter=$1
logical_adapter=$7
diva_dir=$2
bri_num_spids=$3
bri_client_card=$4
bri_card_name="$5"
bri_client_1tr6=0
bri_flag_no_1_tr6=0
bri_ident=$6

diva_cfg_logical_adapter=$8
diva_bri_rev_1=$9
shift
diva_nt_capable=$9

bri_protocol_string="ETSI"
bri_protocol=0
bri_us_protocol=0
bri_ni_protocol=0
cfg_option="none"
cfg_option1="none"
law_options=257
qsig_options=257
bri_rev_1_uses_v6=257
bri_ringer_tone=255

# ---------------------------------------------------------------------------
#  EXTENDED OPTIONS
# ---------------------------------------------------------------------------
bri_ext_options=2
bri_l2_options=4
bri_l2_valid=0
bri_nt2_mode=2
bri_didn_length=100
bri_std_tei=2
bri_p2p_mode=2
bri_tei_value=100
bri_permanent_connection=255
bri_nt_mode=0

bri_spid1="N"
bri_oad1="N"
bri_osa1="N"

bri_spid2="N"
bri_oad2="N"
bri_osa2="N"

bri_spid3="N"
bri_oad3="N"
bri_osa3="N"

bri_spid4="N"
bri_oad4="N"
bri_osa4="N"

bri_spid5="N"
bri_oad5="N"
bri_osa5="N"

bri_spid6="N"
bri_oad6="N"
bri_osa6="N"

bri_spid7="N"
bri_oad7="N"
bri_osa7="N"

bri_spid8="N"
bri_oad8="N"
bri_osa8="N"

bri_process_spids=2
bri_current_spid=1
bri_spid="N"
bri_oad="N"
bri_osa="N"

bri_us_ekts_num_cach_handles=257
bri_us_ekts_begin_conf=257
bri_us_ekts_drop_conf=257
bri_us_ekts_call_transfer=257

# ----------------------------------------------------------------------------
#  Get V6 options
# ----------------------------------------------------------------------------
bri_rev_1_get_v6_option()
{
if [ $((diva_bri_rev_1)) -ne 1 ]
then
  bri_rev_1_uses_v6=0
  return
fi

clear
echo ' -------------------------------------------------------------------------------'
echo "               DO YOU WISH TO USE V.6 PROTOCOL CODE ?"
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (Y/N)[N]: \c"
read bri_rev_1_uses_v6
if [ -z $bri_rev_1_uses_v6 ]
then
bri_rev_1_uses_v6="N"
fi
case $bri_rev_1_uses_v6 in
  Y) bri_rev_1_uses_v6=1
   ;;
  y) bri_rev_1_uses_v6=1
   ;;
  N) bri_rev_1_uses_v6=0
   ;;
  n) bri_rev_1_uses_v6=0
   ;;
  *) bri_rev_1_uses_v6=257
   ;;
esac
}

# ----------------------------------------------------------------------------
#  Get QSIG options
# ----------------------------------------------------------------------------
bri_qsig_options()
{
if [ $((bri_protocol)) -ne 14 ]
then
qsig_options=0
return
fi

clear
echo ' -------------------------------------------------------------------------------'
echo '                PLEASE SELECT QSIG OPTIONS'
echo ' -------------------------------------------------------------------------------'
echo " 0 - Call Reference and CHI 2 Bytes long (default)"
echo " 1 - Call Reference 1 byte, CHI 2 bytes long"
echo " 2 - Call Reference 2 bytes, CHI is 1 byte long"
echo " 3 - Call Reference and CHI 1 byte long"
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection [0]: \c"
read qsig_options
if [ -z $qsig_options ]
then
qsig_options="0"
fi
case $qsig_options in
 0)
  ;;
 1)
  ;;
 2)
  ;;
 3)
  ;;
 *) qsig_options=257
  ;;
esac
}

# ----------------------------------------------------------------------------
#  US EKTS settings
# ----------------------------------------------------------------------------
get_bri_us_ekts_num_cach_handles()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             PLEASE ENTER AMOUNT OF THE CALL APPEARANCES (CALL REFERENCES)'
echo '             IF CACH (CALL APPEARANCE CALL HANDLINS) IS ACTIVE'
echo ' -------------------------------------------------------------------------------'
echo -e "Please enter number (0...20)[0]: \c"
read bri_us_ekts_num_cach_handles
if [ -z $bri_us_ekts_num_cach_handles ]
then
bri_us_ekts_num_cach_handles=0
fi
bri_us_ekts_num_cach_handles=$((bri_us_ekts_num_cach_handles))
if [ $((bri_us_ekts_num_cach_handles)) -ge 21 ]
then
bri_us_ekts_num_cach_handles=257
fi
}

get_bri_us_ekts_begin_conf()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             PLEASE ENTER PROGRAMMABLE VALUE OF'
echo "             'BEGIN CONFERENCE' FEATURE ACTIVATOR"
echo ' -------------------------------------------------------------------------------'
echo -e "Please enter number (0...127)[61]: \c"
read bri_us_ekts_begin_conf
if [ -z $bri_us_ekts_begin_conf ]
then
bri_us_ekts_begin_conf=61
fi
bri_us_ekts_begin_conf=$((bri_us_ekts_begin_conf))
if [ $((bri_us_ekts_begin_conf)) -ge 128 ]
then
bri_us_ekts_begin_conf=257
fi
}

get_bri_us_ekts_drop_conf()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             PLEASE ENTER PROGRAMMABLE VALUE OF'
echo "             'DROP CONFERENCE' FEATURE ACTIVATOR"
echo ' -------------------------------------------------------------------------------'
echo -e "Please enter number (0...127)[63]: \c"
read bri_us_ekts_drop_conf
if [ -z $bri_us_ekts_drop_conf ]
then
bri_us_ekts_drop_conf=63
fi
bri_us_ekts_drop_conf=$((bri_us_ekts_drop_conf))
if [ $((bri_us_ekts_drop_conf)) -ge 128 ]
then
bri_us_ekts_drop_conf=257
fi
}

get_bri_us_ekts_call_transfer()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             PLEASE ENTER PROGRAMMABLE VALUE OF'
echo "             'CALL TRANSFER' FEATURE ACTIVATOR"
echo ' -------------------------------------------------------------------------------'
echo -e "Please enter number (0...127)[62]: \c"
read bri_us_ekts_call_transfer
if [ -z $bri_us_ekts_call_transfer ]
then
bri_us_ekts_call_transfer=62
fi
bri_us_ekts_call_transfer=$((bri_us_ekts_call_transfer))
if [ $((bri_us_ekts_call_transfer)) -ge 128 ]
then
bri_us_ekts_call_transfer=257
fi
}

# ----------------------------------------------------------------------------
#  Generate local tones
# ----------------------------------------------------------------------------
bri_get_ringer_tone()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             GENERATE LOCAL TONES (ALERT/BUSY) IN B-CHANNEL'
echo '             IN CASE TONES NOT PROVIDED BY ISDN EQUIPMENT ?'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (Y/N)[N]: \c"
read bri_ringer_tone
if [ -z $bri_ringer_tone ]
then
bri_ringer_tone="N"
fi
case $bri_ringer_tone in
  Y) bri_ringer_tone=1
    ;;
  y) bri_ringer_tone=1
    ;;
  N) bri_ringer_tone=0
    ;;
  n) bri_ringer_tone=0
    ;;
  *) bri_ringer_tone=255
    ;;
esac
}

# ----------------------------------------------------------------------------
#  Get force Law Options
# ----------------------------------------------------------------------------
bri_law_options()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '                PLEASE SELECT LAW OPTIONS'
echo ' -------------------------------------------------------------------------------'
echo " 0 - NATIONAL DEFAULT (dependent on selected D-channel protocol)"
echo " 1 - force A-Law"
echo " 2 - force u-Law"
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection [0]: \c"
read law_options
if [ -z $law_options ]
then
law_options=0
fi
case $law_options in
 0)
  ;;
 1)
  ;;
 2)
  ;;
 *) law_options=257
  ;;
esac
}

# ----------------------------------------------------------------------------
#  SET SPID'S MANUALLY
# ----------------------------------------------------------------------------
bri_setup_spids()
{
local_default="N"
clear
echo ' -------------------------------------------------------------------------------'
echo "               DO YOU WISH TO SET SPID(s) MANUALLY ?"
echo "               (OR AUTOSPID PROCEDURE WILL BE USED)"
echo ' -------------------------------------------------------------------------------'
if [ $((bri_ni_protocol)) -eq 1 ]
then
local_default="Y"
fi
echo -e "Your selection (Y/N)[$local_default]: \c"
read bri_process_spids
if [ -z $bri_process_spids ]
then
bri_process_spids=$local_default
fi
case $bri_process_spids in
  Y) bri_process_spids=1
   ;;
  y) bri_process_spids=1
   ;;
  N) bri_process_spids=0
   ;;
  n) bri_process_spids=0
   ;;
  *) bri_process_spids=2
   ;;
esac
}

# -----------------------------------------------------------------------------
#  GET SPID's IF NECESSARY
#  U - value undefined
#  N - Value not provided, not set it
# -----------------------------------------------------------------------------
bri_get_spids()
{
local nr=1
local spid_label=1
local port_label=1
local v1="N"
local v2="N"
local v3="N"

bri_port_num_spids=$((bri_num_spids))

while [ $bri_process_spids -eq 2 ]
do
bri_setup_spids
done
if [ $bri_process_spids -eq 0 ]
then
return
fi

if [ $((diva_cfg_logical_adapter)) -ge 1 ]
then
case $(($diva_cfg_logical_adapter)) in
  1) nr=1
     bri_port_num_spids=$(($nr+1))
   ;;
  2) nr=3
     bri_port_num_spids=$(($nr+1))
   ;;
  3) nr=5
     bri_port_num_spids=$(($nr+1))
   ;;
  4) nr=7
     bri_port_num_spids=$(($nr+1))
   ;;
esac
fi

while [ $((nr)) -le $((bri_port_num_spids)) ]
do

v1="N"
v2="N"
v3="N"

clear
echo ' -------------------------------------------------------------------------------'
if [ $((bri_num_spids)) -le 2 ]
then
echo "                         PLEASE ENTER SPID $((nr)) VALUES"
spid_label=$((nr))
else
case $((nr)) in
  1) port_label=1
     spid_label=1
   ;;
  2) port_label=1
     spid_label=2
   ;;
  3) port_label=2
     spid_label=1
   ;;
  4) port_label=2
     spid_label=2
   ;;
  5) port_label=3
     spid_label=1
   ;;
  6) port_label=3
     spid_label=2
   ;;
  7) port_label=4
     spid_label=1
   ;;
  8) port_label=4
     spid_label=2
   ;;
esac
fi
echo "              PLEASE ENTER SPID $spid_label PORT $port_label VALUES (SPID and MSN)"
echo '                                OR PRESS ENTER'
echo '                    IF YOU DO NOT PROVIDE PARTICULAR VALUE'
echo ' -------------------------------------------------------------------------------'
echo -e "SPID value: \c"
read v1
echo -e "MSN       : \c"
read v2
#
# do not ask for subaddress, set it to not provided
#
# echo -e "OSA : \c"
# read v3
v3="N"

if [ -z $v1 ]
then
v1="N"
fi
if [ -z $v2 ]
then
v2="N"
fi
if [ -z $v3 ]
then
v3="N"
fi

#if [ $v1 == "n" ]
#then
#v1="N"
#fi
#if [ $v2 == "n" ]
#then
#v2="N"
#fi
#if [ $v3 == "n" ]
#then
#v3="N"
#fi

#if [ $v1 == "" ]
#then
#v1="N"
#fi
#if [ $v2 == "" ]
#then
#v2="N"
#fi
#if [ $v3 == "" ]
#then
#v3="N"
#fi

case $((nr)) in
  1) bri_spid1=$v1
     bri_oad1=$v2
     bri_osa1=$v3
   ;;
  2) bri_spid2=$v1
     bri_oad2=$v2
     bri_osa2=$v3
   ;;
  3) bri_spid3=$v1
     bri_oad3=$v2
     bri_osa3=$v3
   ;;
  4) bri_spid4=$v1
     bri_oad4=$v2
     bri_osa4=$v3
   ;;
  5) bri_spid5=$v1
     bri_oad5=$v2
     bri_osa5=$v3
   ;;
  6) bri_spid6=$v1
     bri_oad6=$v2
     bri_osa6=$v3
   ;;
  7) bri_spid7=$v1
     bri_oad7=$v2
     bri_osa7=$v3
   ;;
  8) bri_spid8=$v1
     bri_oad8=$v2
     bri_osa8=$v3
   ;;
esac

nr=$(($nr+1))
done
}

# ----------------------------------------------------------------------------
#  Select generic configuration
# ----------------------------------------------------------------------------
divas_bri_generic_profile()
{
clear
echo ' -------------------------------------------------------------------------------'
echo "      PLEASE SELECT OPERATION MODE FOR"
echo -n "      '$bri_card_name'"
if [ $((diva_cfg_logical_adapter)) -ge 1 ]
then
echo ", PORT $diva_cfg_logical_adapter"
else
echo ""
fi
echo ' -------------------------------------------------------------------------------'
echo '  1 - S0 TE mode operation with D-channel'
if [ $((diva_nt_capable)) -eq 1 ]
then
echo '  2 - S0 NT mode operation with D-channel'
fi
echo '      Typical usage: RAS Server, FAX Server, Unified Messaging Server,'
echo '                     Wireless Access Server, WAP Server,'
echo '                     VoIP (Media Gateway),'
echo '                     PABX or Link between 2 PABX'
if [ $((diva_nt_capable)) -eq 1 ]
then
echo '  3 - S0 TE mode operation, permanent connection'
echo '  4 - S0 NT mode operation, permanent connection'
else
echo '  2 - S0 TE mode operation, permanent connection'
fi
echo '      Typical usage: LAN to LAN coupling using leased line'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection [1]: \c"
read bri_permanent_connection
if [ -z $bri_permanent_connection ]
then
bri_permanent_connection=1
fi
if [ $((diva_nt_capable)) -ne 1 ]
then
  case $bri_permanent_connection in
    1) bri_permanent_connection=0
     ;;
    2) bri_permanent_connection=1
     ;;
    *) bri_permanent_connection=255
     ;;
  esac
  bri_nt_mode=0
else
  case $bri_permanent_connection in
    1) bri_permanent_connection=0
       bri_nt_mode=0
     ;;
    2) bri_permanent_connection=0
       bri_nt_mode=1
     ;;
    3) bri_permanent_connection=1
       bri_nt_mode=0
     ;;
    4) bri_permanent_connection=1
       bri_nt_mode=1
     ;;
    *) bri_permanent_connection=255
       bri_nt_mode=0
     ;;
  esac
fi
if [ $((bri_nt_mode)) -eq 1 ]
then
bri_p2p_mode=1
bri_std_tei=1
fi
}

# ----------------------------------------------------------------------------
#  Select D-channel protocol and write it in protocol variable
# ----------------------------------------------------------------------------
divas_bri_protocol()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '                PLEASE SELECT D-CHANNEL PROTOCOL (SWITCH TYPE)'
echo ' -------------------------------------------------------------------------------'
if [ $(($bri_client_card)) -eq 0 ]
then
  echo "  1 - 1TR6     Germany, old protocol for PABX"
else
  if [ -f $diva_dir/DivasC6.o ]
  then
    echo "  1 - 1TR6     Germany, old protocol for PABX"
  else
    bri_flag_no_1_tr6=1
  fi
fi

echo "  2 - ETSI     DSS1, Europe, Germany"
echo "  3 - FRANC    VN3, France, old protocol for PABX"
echo "  4 - BELG     NET3, Belgium, old protocol for PABX"
echo "  5 - NI       NI1, NI2, North America, National ISDN"
echo "  6 - 5ESS     5ESS, North America, AT&T"
echo "  7 - JAPAN    Japan, INS-NET64"
echo "  8 - ATEL     ATEL, Australia, old TPH1962"
echo "  9 - US       North America, Auto Detect"
echo " 10 - ITALY    DSS1, Italy"
echo " 11 - TWAN     DSS1, Taiwan"
echo " 12 - AUSTRAL  Australia, Microlink (TPH1962), On Ramp ETSI"
echo " 13 - HONGKONG Hongkong"
if [ $((bri_permanent_connection)) -eq 0 -a $((bri_client_card)) -eq 0 ]
then
echo " 14 - QSIG     QSIG, Intra PABX link protocol"
fi
echo " 15 - EWSD     Siemens, National ISDN EWSD"
echo " 16 - 5ESS_NI  5ESS switch National ISDN Lucent"
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection: \c"
read bri_protocol
case $bri_protocol in
  1) bri_protocol_string="1TR6"
     bri_protocol=1
   ;;
  2) bri_protocol_string="ETSI"
     bri_protocol=2
   ;;
  3) bri_protocol_string="FRANC"
     bri_protocol=3
   ;;
  4) bri_protocol_string="BELG"
     bri_protocol=4
   ;;
  5) bri_protocol_string="NI"
     bri_protocol=5
     bri_us_protocol=1
     bri_ni_protocol=1
   ;;
  6) bri_protocol_string="5ESS"
     bri_protocol=6
     bri_us_protocol=1
   ;;
  7) bri_protocol_string="JAPAN"
     bri_protocol=7
   ;;
  8) bri_protocol_string="ATEL"
     bri_protocol=8
   ;;
  9) bri_protocol_string="US"
     bri_protocol=9
     bri_us_protocol=1
   ;;
 10) bri_protocol_string="ITALY"
     bri_protocol=10
   ;;
 11) bri_protocol_string="TWAN"
     bri_protocol=11
   ;;
 12) bri_protocol_string="AUSTRAL"
     bri_protocol=12
   ;;
 13) bri_protocol_string="HONGKONG"
     bri_protocol=13
   ;;
 14) bri_protocol_string="QSIG"
     bri_protocol=14
   ;;
  15) bri_protocol_string="EWSD"
     bri_protocol=15
     bri_us_protocol=1
     bri_ni_protocol=1
   ;;
  16) bri_protocol_string="5ESS_NI"
     bri_protocol=16
     bri_us_protocol=1
     bri_ni_protocol=1
   ;;
  *) bri_protocol_string="ETSI"
     bri_protocol=0
     bri_us_protocol=0
   ;;
esac

if [ $((bri_protocol)) -eq 14 ]
then
  if [ $((diva_bri_rev_1)) -eq 1 ]
  then
    bri_rev_1_uses_v6=1
  fi
fi

if [ $((bri_permanent_connection)) -eq 1 -o $((bri_client_card)) -eq 1 ]
then
  if [ $((bri_protocol)) -eq 14 ]
  then
    bri_protocol_string="ETSI"
    bri_protocol=0
    bri_us_protocol=0
  fi
fi

if [ $(($bri_flag_no_1_tr6)) -eq 1 ]
then
  if [ $(($bri_protocol)) -eq 1 ]
  then
    bri_protocol_string="ETSI"
    bri_protocol=0
    bri_us_protocol=0
  fi
fi
}

# -----------------------------------------------------------------------------
#  NT2 MODE OPTIONS
# -----------------------------------------------------------------------------
bri_use_nt2()
{
clear
echo ' -------------------------------------------------------------------------------'
echo "             SELECT NT2 (DIRECT DIAL IN, DIRECT INWARD DIALING) MODE ?"
echo ' -------------------------------------------------------------------------------'
echo -e " Your selection (Y/N)[N]: \c"
read bri_nt2_mode
if [ -z $bri_nt2_mode ]
then
bri_nt2_mode="N"
fi
case $bri_nt2_mode in
 Y) bri_nt2_mode=1
  ;;
 y) bri_nt2_mode=1
  ;;
 N) bri_nt2_mode=0
  ;;
 n) bri_nt2_mode=0
  ;;
 *) bri_nt2_mode=2
  ;;
esac
}

bri_get_didn_length()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '             PLEASE ENTER DIRECT INWARD DIALING NUMBER LENGTH'
echo ' -------------------------------------------------------------------------------'
echo -e "Please enter number (0...20)[0]: \c"
read bri_didn_length
if [ -z $bri_didn_length ]
then
bri_didn_length=0
fi
case $bri_didn_length in
  0)
   ;;
  1)
   ;;
  2)
   ;;
  3)
   ;;
  4)
   ;;
  5)
   ;;
  6)
   ;;
  7)
   ;;
  8)
   ;;
  9)
   ;;
 10)
   ;;
 11)
   ;;
 12)
   ;;
 13)
   ;;
 14)
   ;;
 15)
   ;;
 16)
   ;;
 17)
   ;;
 18)
   ;;
 19)
   ;;
 20)
   ;;

  *) bri_didn_length=100
   ;;
esac
}

# -----------------------------------------------------------------------------
# DO PROCESS EXTENDED OPTIONS
# -----------------------------------------------------------------------------
divas_bri_ext_options()
{
clear
echo ' -------------------------------------------------------------------------------'
echo '              DO YOU WISH TO CONFIGURE ADVANCED PARAMETERS ?'
echo ' -------------------------------------------------------------------------------'
echo -e " Your selection (Y/N)[N]: \c"
read bri_ext_options
if [ -z $bri_ext_options ]
then
bri_ext_options="N"
fi
case $bri_ext_options in
 Y) bri_ext_options=1
  ;;
 y) bri_ext_options=1
  ;;
 N) bri_ext_options=0
  ;;
 n) bri_ext_options=0
  ;;
 *) bri_ext_options=2
  ;;
esac
}

# -----------------------------------------------------------------------------
# ASK FOR L2 OPTIONS
# -----------------------------------------------------------------------------
bri_get_l2_options()
{
# QSIG always uses no disc
if [ $((bri_protocol)) -eq 14 ]
then
bri_l2_options=1
return
fi

clear
echo ' -------------------------------------------------------------------------------'
echo '            PLEASE SELECT D-CHANNEL LAYER 2 ACTIVATION POLICY'
echo ' -------------------------------------------------------------------------------'
echo "  0 - On demand"
echo "  1 - Deactivation only by NT side"
echo "  2 - Always active (default)"
echo "  3 - Always active, mode 2 (rarely used)"
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection [2]: \c"
read bri_l2_options
if [ -z $bri_l2_options ]
then
bri_l2_options=2
fi
case $bri_l2_options in
  0)
   ;;
  1)
   ;;
  2)
   ;;
  3)
   ;;
  *) bri_l2_options=4
   ;;
esac
}

bri_get_p2p_mode()
{
# QSIG always P2P
if [ $((bri_protocol)) -eq 14 ]
then
bri_p2p_mode=0
return
fi

clear
echo ' -------------------------------------------------------------------------------'
echo '            PLEASE SELECT S0 INTERFACE MODE'
echo ' -------------------------------------------------------------------------------'
echo ' 1 - Point to Multipoint'
echo ' 2 - Point to Point'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection [1]: \c"
read bri_p2p_mode
if [ -z $bri_p2p_mode ]
then
bri_p2p_mode=1
fi
case $bri_p2p_mode in
  1) bri_p2p_mode=0
   ;;
  2) bri_p2p_mode=1
   ;;
  *) bri_p2p_mode=2
   ;;
esac
}

bri_get_std_tei()
{
# QSIG always uses TEI0
if [ $((bri_protocol)) -eq 14 ]
then
bri_std_tei=1
return
fi

clear
echo ' -------------------------------------------------------------------------------'
echo '                    DO YOU USE STANDARD TEI (TEI 0) ?'
echo ' -------------------------------------------------------------------------------'
echo -e "Your selection (Y/N)[Y]: \c"
read bri_std_tei
if [ -z $bri_std_tei ]
then
bri_std_tei="Y"
fi
case $bri_std_tei in
  Y) bri_std_tei=1
   ;;
  y) bri_std_tei=1
   ;;
  N) bri_std_tei=0
   ;;
  n) bri_std_tei=0
   ;;
  *) bri_std_tei=2
   ;;
esac
}

bri_get_tei_value()
{
local nr=0
clear
echo ' -------------------------------------------------------------------------------'
echo '                     PLEASE ENTER TEI VALUE [0...63]'
echo ' -------------------------------------------------------------------------------'
echo -e "TEI value [0]: \c"
read bri_tei_value
if [ -z $bri_tei_value ]
then
bri_tei_value=0
fi
nr=$((bri_tei_value))
if [ $nr != $bri_tei_value ]
then
bri_tei_value=100
else
 if [ $nr -ge 64 ]
 then
  bri_tei_value=100
 fi
fi
}



# -----------------------------------------------------------------------------
# MAIN()
# -----------------------------------------------------------------------------
while [ $bri_permanent_connection -eq 255 ]
do
divas_bri_generic_profile
done

while [ $bri_protocol -eq 0 ]
do
divas_bri_protocol
done

if [ $bri_permanent_connection -eq 0 ]
then

 if [ $bri_us_protocol -eq 1 ]
 then
 bri_get_spids
 fi

 while [ $bri_ext_options -eq 2 ]
 do
  divas_bri_ext_options
 done
else
 bri_ext_options=0
fi

if [ $bri_ext_options -eq 1 ]
then

while [ $((diva_bri_rev_1)) -eq 1 -a $((bri_rev_1_uses_v6)) -eq 257 ]
do
bri_rev_1_get_v6_option
done

if [ $bri_us_protocol -eq 0 ]
then
while [ $bri_nt2_mode -eq 2 ]
do
 bri_use_nt2
done
else
bri_nt2_mode=0
fi
if [ $bri_nt2_mode -eq 1 ]
then
 while [ $bri_didn_length -eq 100 ]
 do
  bri_get_didn_length
 done
fi

while [ $bri_l2_options -eq 4 ]
do
bri_get_l2_options
done
bri_l2_valid=1

while [ $law_options -eq 257 ]
do
 bri_law_options
done

while [ $qsig_options -eq 257 ]
do
 bri_qsig_options
done

while [ $bri_p2p_mode -eq 2 ]
do
bri_get_p2p_mode
done
if [ $bri_p2p_mode -eq 1 ]
then
  while [ $bri_std_tei -eq 2 ]
  do
  bri_get_std_tei
  done
# 
# NON STANDARD TEI SELECTED
#
  if [ $bri_std_tei -eq 0 ]
  then
   while [ $bri_tei_value -eq 100 ]
   do
   bri_get_tei_value
   done
  fi
fi

if [ $((bri_client_card)) -eq 0 ]
then
  if [ $bri_p2p_mode -eq 1 -o $((bri_protocol)) -eq 14 ]
  then
    while [ $((bri_ringer_tone)) -eq 255 ]
    do
      bri_get_ringer_tone
    done
  fi
fi

#
# EKTS SETTINGS
#

if [ $((bri_ni_protocol)) -eq 1 ]
then
  if [ $((diva_bri_rev_1)) -eq 0 -o $((bri_rev_1_uses_v6)) -eq 1 ]
  then
    while [ $((bri_us_ekts_num_cach_handles)) -eq 257 ]
    do
      get_bri_us_ekts_num_cach_handles
    done

    while [ $((bri_us_ekts_begin_conf)) -eq 257 ]
    do
      get_bri_us_ekts_begin_conf
    done

    while [ $((bri_us_ekts_drop_conf)) -eq 257 ]
    do
      get_bri_us_ekts_drop_conf
    done

    while [ $((bri_us_ekts_call_transfer)) -eq 257 ]
    do
      get_bri_us_ekts_call_transfer
    done
  fi
fi

else
# ----------------------------------------------------------------------------
#  DEFAULTS FOR EXTENDED OPTIONS
# ----------------------------------------------------------------------------
bri_l2_options=0
bri_nt2_mode=0
bri_didn_length=0
bri_l2_valid=0
bri_p2p_mode=0
bri_std_tei=0
law_options=0
qsig_options=0
bri_ringer_tone=0

# QSIG defaults
if [ $((bri_protocol)) -eq 14 ]
then
  bri_l2_options=1
  bri_p2p_mode=1
  bri_std_tei=1
  bri_l2_valid=1
fi

if [ $((bri_nt_mode)) -eq 1 ]
then
bri_p2p_mode=1
bri_std_tei=1
fi

fi

# ----------------------------------------------------------------------------
#  WRITE CONFIGURATION TO FILE
# ----------------------------------------------------------------------------
if [ $(($bri_client_card)) -eq 0 ]
then
if [ -f $diva_dir/divactrl ]
then
bri_load_command=$diva_dir
else
bri_load_command=/sbin
fi
bri_load_command="$bri_load_command/divactrl load"
if [ $((diva_cfg_logical_adapter)) -eq 1 ]
then
bri_load_command="$bri_load_command -SeparateConfig"
fi
bri_load_command="$bri_load_command -c $logical_adapter -f $bri_protocol_string"

if [ $((diva_cfg_logical_adapter)) -ge 2 ]
then
bri_load_command="-f$((diva_cfg_logical_adapter-1)) $bri_protocol_string"
fi

else
 if [ $(($bri_client_1tr6)) -eq 0 ]
  then
   bri_load_command="insmod -f $diva_dir/DivasC.o divascm_cmd_line=\""
   bri_load_command="$bri_load_command -f $bri_protocol_string"
 else
   bri_load_command="insmod -f $diva_dir/DivasC6.o divascm_cmd_line=\""
 fi
fi

# ---------------------------------------------------------------------------
#  ADD L2 OPTIONS
# ---------------------------------------------------------------------------
if [ $bri_l2_valid -eq 1 ]
then
bri_load_command="$bri_load_command -s"
if [ $((diva_cfg_logical_adapter)) -ge 2 ]
then
bri_load_command="$bri_load_command$((diva_cfg_logical_adapter-1))"
fi
bri_load_command="$bri_load_command $bri_l2_options"
fi

# ---------------------------------------------------------------------------
#  ADD NT2 OPTIONS
# ---------------------------------------------------------------------------
if [ $bri_nt2_mode -eq 1 ]
then
 cfg_option="-n"
 if [ $((diva_cfg_logical_adapter)) -ge 2 ]
 then
  cfg_option="-n$((diva_cfg_logical_adapter-1))"
 fi
 if [ $bri_didn_length -eq 0 ]
 then
  bri_load_command="$bri_load_command $cfg_option 0"
 else
  bri_load_command="$bri_load_command $cfg_option $bri_didn_length"
 fi
fi

# ----------------------------------------------------------------------------
# P2P (TEI) Options
# ----------------------------------------------------------------------------
if [ $bri_p2p_mode -eq 1 ]
then
  cfg_option="-u"
  cfg_option1="-t"
  if [ $((diva_cfg_logical_adapter)) -ge 2 ]
  then
    cfg_option="-u$((diva_cfg_logical_adapter-1))"
    cfg_option1="-t$((diva_cfg_logical_adapter-1))"
  fi
  if [ $bri_std_tei -eq 1 ]
  then
  bri_load_command="$bri_load_command $cfg_option"
  else
  bri_load_command="$bri_load_command $cfg_option1 $((bri_tei_value))"
  fi
fi

# ----------------------------------------------------------------------------
#  PERMANENT CONNECTION
# ----------------------------------------------------------------------------
if [ $bri_permanent_connection -eq 1 ]
then
bri_load_command="$bri_load_command -p"
if [ $((diva_cfg_logical_adapter)) -ge 2 ]
then
bri_load_command="$bri_load_command$((diva_cfg_logical_adapter-1))"
fi
bri_load_command="$bri_load_command 1"
fi

# ----------------------------------------------------------------------------
#  WRITE SPIDS
# ----------------------------------------------------------------------------
if [ $bri_process_spids -eq 1 ]
then
while [ $((bri_current_spid)) -le $((bri_num_spids)) ]
do
case $((bri_current_spid)) in
  1) bri_spid=$bri_spid1
     bri_oad=$bri_oad1
     bri_osa=$bri_osa1
   ;;
  2) bri_spid=$bri_spid2
     bri_oad=$bri_oad2
     bri_osa=$bri_osa2
   ;;
  3) bri_spid=$bri_spid3
     bri_oad=$bri_oad3
     bri_osa=$bri_osa3
   ;;
  4) bri_spid=$bri_spid4
     bri_oad=$bri_oad4
     bri_osa=$bri_osa4
   ;;
  5) bri_spid=$bri_spid5
     bri_oad=$bri_oad5
     bri_osa=$bri_osa5
   ;;
  6) bri_spid=$bri_spid6
     bri_oad=$bri_oad6
     bri_osa=$bri_osa6
   ;;
  7) bri_spid=$bri_spid7
     bri_oad=$bri_oad7
     bri_osa=$bri_osa7
   ;;
  8) bri_spid=$bri_spid8
     bri_oad=$bri_oad8
     bri_osa=$bri_osa8
   ;;
esac

if [ $bri_spid != "N" ]
then
bri_load_command="$bri_load_command -$((bri_current_spid))spid $bri_spid"
fi
if [ $bri_oad != "N" ]
then
bri_load_command="$bri_load_command -$((bri_current_spid))oad $bri_oad"
fi
if [ $bri_osa != "N" ]
then
bri_load_command="$bri_load_command -$((bri_current_spid))osa $bri_osa"
fi

bri_current_spid=$(($bri_current_spid+1))

done
fi

# -----------------------------------------------------------------------------
#  ADD LAW OPTIONS
# -----------------------------------------------------------------------------
if [ $law_options != 0 ]
then
cfg_option="-m"
if [ $((diva_cfg_logical_adapter)) -ge 2 ]
then
cfg_option="$cfg_option$((diva_cfg_logical_adapter-1))"
fi
bri_load_command="$bri_load_command $cfg_option $law_options"
fi

# -----------------------------------------------------------------------------
#  ADD QSIG OPTIONS
# -----------------------------------------------------------------------------
if [ $qsig_options != 0 ]
then
cfg_option="-q"
if [ $((diva_cfg_logical_adapter)) -ge 2 ]
then
cfg_option="$cfg_option$((diva_cfg_logical_adapter-1))"
fi
bri_load_command="$bri_load_command $cfg_option $qsig_options"
fi

# -----------------------------------------------------------------------------
#  ADD NT MODE
# -----------------------------------------------------------------------------
if [ $((bri_nt_mode)) -ne 0 ]
then
cfg_option="-x"
if [ $((diva_cfg_logical_adapter)) -ge 2 ]
then
cfg_option="$cfg_option$((diva_cfg_logical_adapter-1))"
fi
bri_load_command="$bri_load_command $cfg_option"
fi

# -----------------------------------------------------------------------------
#  ADD RINGER TONE OPTIONS
# -----------------------------------------------------------------------------
if [ $((bri_ringer_tone)) -eq 1 ]
then
  cfg_option="-RingerTone"
  if [ $((diva_cfg_logical_adapter)) -ge 2 ]
  then
    cfg_option="$cfg_option$((diva_cfg_logical_adapter-1))"
  fi
  bri_load_command="$bri_load_command $cfg_option 1"
fi

# ----------------------------------------------------------------------------
#  ADD V6 OPTIONS
# ----------------------------------------------------------------------------
if [ $((bri_rev_1_uses_v6)) -eq 1 ]
then
bri_load_command="$bri_load_command -vb6"
fi

# ----------------------------------------------------------------------------
#  ADD EKTS SETTINGS
# ----------------------------------------------------------------------------
if [ $((bri_us_ekts_num_cach_handles)) -ne 257 ]
then
  cfg_option="-UsEktsCachHandles"
  if [ $((diva_cfg_logical_adapter)) -ge 2 ]
  then
    cfg_option="$cfg_option$((diva_cfg_logical_adapter-1))"
  fi
  bri_load_command="$bri_load_command $cfg_option $((bri_us_ekts_num_cach_handles))"
fi

if [ $((bri_us_ekts_begin_conf)) -ne 257 ]
then
  cfg_option="-UsEktsBeginConf"
  if [ $((diva_cfg_logical_adapter)) -ge 2 ]
  then
    cfg_option="$cfg_option$((diva_cfg_logical_adapter-1))"
  fi
  bri_load_command="$bri_load_command $cfg_option $((bri_us_ekts_begin_conf))"
fi

if [ $((bri_us_ekts_drop_conf)) -ne 257 ]
then
  cfg_option="-UsEktsDropConf"
  if [ $((diva_cfg_logical_adapter)) -ge 2 ]
  then
    cfg_option="$cfg_option$((diva_cfg_logical_adapter-1))"
  fi
  bri_load_command="$bri_load_command $cfg_option $((bri_us_ekts_drop_conf))"
fi

if [ $((bri_us_ekts_call_transfer)) -ne 257 ]
then
  cfg_option="-UsEktsCallTransfer"
  if [ $((diva_cfg_logical_adapter)) -ge 2 ]
  then
    cfg_option="$cfg_option$((diva_cfg_logical_adapter-1))"
  fi
  bri_load_command="$bri_load_command $cfg_option $((bri_us_ekts_call_transfer))"
fi

# ----------------------------------------------------------------------------
#  ADD LOAD STRING TO THE BRI LOAD SCRIPT
# ----------------------------------------------------------------------------
clear
if [ $(($bri_client_card)) -ne 0 ]
then
bri_load_command="$bri_load_command -c $bri_ident\""
fi

if [ $((diva_cfg_logical_adapter)) -ge 1 ]
then
bri_load_command="$bri_load_command \\"
fi

echo $bri_load_command >> $diva_dir/divas_cfg.rc

